//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <math.h>
#pragma hdrstop

#include "Demo.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma link "Spin"
#pragma link "xyGraph"
#pragma resource "*.dfm"
TForm1 *Form1;

double parms[] = {0.5, 1.5, 4};

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PlottingCBClick(TObject *Sender)
{
  xyGraph1->Plotting = PlottingCB->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoStepCBClick(TObject *Sender)
{
  if (internal ) return;
  xyGraph1->XAxis->AutoStepping = AutoStepCB->Checked;
  xyGraph1->YAxis->AutoStepping = AutoStepCB->Checked;
  if ( AutoStepCB->Checked )
  {
    internal = true;
    XStepEdit->Text = FloatToStrF(xyGraph1->XAxis->StepSize, ffFixed, 10, 6);
    YStepEdit->Text = FloatToStrF(xyGraph1->YAxis->StepSize, ffFixed, 10, 6);
    internal = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoXSizeCBClick(TObject *Sender)
{
  if (internal) return;
  xyGraph1->XAxis->AutoSizing = AutoXSizeCB->Checked;
  if (AutoXSizeCB->Checked)
  {
    internal = true;
    XMinEdit->Text = FloatToStrF(xyGraph1->XAxis->Min, ffFixed, 10, 6);
    XMaxEdit->Text = FloatToStrF(xyGraph1->XAxis->Max, ffFixed, 10, 6);
    internal = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoYSizeCBClick(TObject *Sender)
{
  if (internal) return;
  xyGraph1->YAxis->AutoSizing = AutoYSizeCB->Checked;
  if (AutoYSizeCB->Checked )
  {
    internal = true;
    YMinEdit->Text = FloatToStrF(xyGraph1->YAxis->Min, ffFixed, 10, 6);
    YMaxEdit->Text = FloatToStrF(xyGraph1->YAxis->Max, ffFixed, 10, 6);
    internal = false;
  };
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AllowedOutCBClick(TObject *Sender)
{
  xyGraph1->Appearance->PlotOffGraph = AllowedOutCB->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XLogCBClick(TObject *Sender)
{
  xyGraph1->XAxis->LogScale = XLogCB->Checked;
  XStepEdit->OnExit(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YLogCBClick(TObject *Sender)
{
  xyGraph1->YAxis->LogScale = YLogCB->Checked;
  YStepEdit->OnExit(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XMinEditChange(TObject *Sender)
{
  if (internal) return;
  try
  {
     xyGraph1->XAxis->Min = StrToFloat(XMinEdit->Text);
     internal = true;
     AutoXSizeCB->Checked = false;
     internal = false;
  }
  catch(...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XMinEditExit(TObject *Sender)
{
  XMinEdit->Text = FloatToStrF(xyGraph1->XAxis->Min, ffFixed, 10, 6);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XMaxEditExit(TObject *Sender)
{
  XMaxEdit->Text = FloatToStrF(xyGraph1->XAxis->Max, ffFixed, 10, 6);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XStepEditChange(TObject *Sender)
{
  if (internal) return;
  try
  {
  xyGraph1->XAxis->StepSize = StrToFloat(XStepEdit->Text);
  internal = true;
  AutoStepCB->Checked = false;
  internal = false;
  }
  catch(...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XStepEditExit(TObject *Sender)
{
  XStepEdit->Text = FloatToStrF(xyGraph1->XAxis->StepSize, ffFixed, 10, 6);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YMinEditExit(TObject *Sender)
{
  YMinEdit->Text = FloatToStrF(xyGraph1->YAxis->Min, ffFixed, 10, 6);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YMaxEditExit(TObject *Sender)
{
  YMaxEdit->Text = FloatToStrF(xyGraph1->YAxis->Max, ffFixed, 10, 6);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YStepEditExit(TObject *Sender)
{
  YStepEdit->Text = FloatToStrF(xyGraph1->YAxis->StepSize, ffFixed, 10, 6);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XMaxEditChange(TObject *Sender)
{
  if (internal) return;
  try
  {
  xyGraph1->XAxis->Max = StrToFloat(XMaxEdit->Text);
  internal = true;
  AutoXSizeCB->Checked = false;
  internal = false;
  }
  catch(...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YMinEditChange(TObject *Sender)
{
  if (internal) return;
  try
  {
  xyGraph1->YAxis->Min = StrToFloat(YMinEdit->Text);
  internal = true;
  AutoYSizeCB->State = cbUnchecked;
  internal = false;
  }
  catch(...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YMaxEditChange(TObject *Sender)
{
  if (internal) return;
  try
  {
     xyGraph1->YAxis->Max = StrToFloat(YMaxEdit->Text);
     internal = true;
     AutoYSizeCB->State = cbUnchecked;
     internal = false;
  }
  catch(...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YStepEditChange(TObject *Sender)
{
  if (internal) return;
  try
  {
  xyGraph1->YAxis->StepSize = StrToFloat(YStepEdit->Text);
  internal = true;
  AutoStepCB->Checked = false;
  internal = false;
  }
  catch(...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MinStepEditChange(TObject *Sender)
{
  xyGraph1->Appearance->MinSteps = StrToInt(MinStepEdit->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MinStepEditExit(TObject *Sender)
{
  MinStepEdit->Text = IntToStr(xyGraph1->Appearance->MinSteps);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XLogTickEditChange(TObject *Sender)
{
  xyGraph1->XAxis->LogCycleDivisions = StrToInt(XLogTickEdit->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XLogTickEditExit(TObject *Sender)
{
  XLogTickEdit->Text = IntToStr(xyGraph1->XAxis->LogCycleDivisions);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YLogTickEditChange(TObject *Sender)
{
  xyGraph1->YAxis->LogCycleDivisions = StrToInt(YLogTickEdit->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YLogTickEditExit(TObject *Sender)
{
  YLogTickEdit->Text = IntToStr(xyGraph1->YAxis->LogCycleDivisions);
	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SeriesSEChange(TObject *Sender)
{
  int sN, j;
  long index;
  double x, y, r;
  int more;

  StringGrid1->Cols[0]->Clear();
  StringGrid1->Cols[1]->Clear();
  StringGrid1->Cells[0][0] = "Time";
  StringGrid1->Cells[1][0] = "Temp";
  sN = StrToInt(SeriesSE->Text);
  j = 1;
  more = xyGraph1->Series[sN]->GetFirstPoint(x, y, r, index);
  while (more )
  {
    StringGrid1->Cells[0][j] = FloatToStrF(x, ffFixed, 10, 6);
    StringGrid1->Cells[1][j] = FloatToStrF(y, ffFixed, 10, 6);
    more = xyGraph1->Series[sN]->GetNextPoint(x, y, r, index);
    j++;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetSeriesBtnClick(TObject *Sender)
{
  TColor Colors[9] = {clBlack, clBlue, clTeal, clGreen,
            clLime, clYellow, clMaroon, clRed, clPurple};

  int j, sN;
  double xv, yv;
  TColor color;

  sN = SeriesSE->Value;
  xyGraph1->Series[sN]->AllowDuplicates = true;
  xyGraph1->Series[sN]->Active = true;
  xyGraph1->Series[sN]->Clear();
  xyGraph1->Series[sN]->AutoZero = false;
  xyGraph1->Series[sN]->DrawLine = LinesCB->Checked;
  xyGraph1->Series[sN]->DrawPoints = PointsCB->Checked;
  xyGraph1->Series[sN]->PointSize = 6;
  j = 1;
  while ( j < StringGrid1->RowCount )
  {
    try
    {
      xv = StrToFloat(StringGrid1->Cells[0][j]);
      yv = StrToFloat(StringGrid1->Cells[1][j]);
      xyGraph1->Series[sN]->ValueAt[xv] = yv;
      j++;
    }
    catch(...)
    {
       break;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RandomBtnClick(TObject *Sender)
{
  int sN, j;
  int xRange, yRange;
  double xv, yv, xOffset, yOffset;
  int holdPlotting;

  holdPlotting = xyGraph1->Plotting;
  xyGraph1->Plotting = false;
  for (sN = 1;sN < 7; sN++)
  {
      xyGraph1->Series[sN]->AllowDuplicates = true;
      xyGraph1->Series[sN]->Active = true;
      xyGraph1->Series[sN]->Clear();
      xyGraph1->Series[sN]->AutoZero = false;
      xyGraph1->Series[sN]->DrawLine = true;
      xyGraph1->Series[sN]->PointSize = 6;

    xRange = 1 + random(10);
    yRange = 1 + random(15);
    xOffset = xRange/2;
    yOffset = 1; {random(yRange / 5) - yRange + 1;}
    for (j = 1; j< sN+2; j++)
    {
      xv = (random(xRange) + xOffset);
      yv = (random(yRange) + yOffset);
      xyGraph1->Series[sN]->ValueAt[xv] = yv;
    };
  };
  xyGraph1->Plotting = holdPlotting;
}


double __fastcall Fn(double x, void *p)
{
   double *pA =  (double *)p;
   return(1/((x - pA[0])*(x - pA[1])*(x - pA[2])) + 1);
//   return sin(x) + sin(3*x)/3 + sin(5*x)/5 + sin(7*x)/7; //..(square wave)
};


//---------------------------------------------------------------------------
void __fastcall TForm1::DrawFnBtnClick(TObject *Sender)
{
  xyGraph1->DrawFunction(Fn, parms, 0, 0, clGreen, psSolid, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PrintBtnClick(TObject *Sender)
{
/*
  if ( MessageBox("Print the graph?", "Heading", MB_YESNO ) == IDYES)
  {
    /*
    Print multiple copies on page:
    Printer->BeginDoc;
      xyGraph1->PrintScalePct = 48;
      xyGraph1->PrintXOffsetPct = 0;
      xyGraph1->PrintOnPage;
      xyGraph1->PrintXOffsetPct = 52;
      xyGraph1->PrintOnPage;
    Printer->EndDoc;
    * /
    xyGraph1->Print();
  }
  */
  xyGraph1->Print();
}
//---------------------------------------------------------------------------



